// CRHuman.h: CRHuman NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//	[solids̏]
//(㔼gA̋j
//0:Waist(),1:Abdomen(),2:Chest(),3:Head(),
//(㔼gAErj
//4:soRUArm(r),5:soRFArm,(Or)6:soRHand()
//(㔼gArj
//7:soLUArm(r),8:soLFArm(Or),9:soLHand()
//(gAEj
//10:soRThigh(),11:soRLThigh(),12:soRHeel(),13:soRToe(ܐ)
//(gAEj
//14:soLThigh(),15:soLLThigh(),16:soLHeel(),17:soLToe(ܐ)
//////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//	[joints̏]
//-------	  㔼g   --------------
//	(j
//0:joWaist1(-X), 1:joWaist2(Z), 2:joWaist3(-Y)
//	(j
//3:joChest1(-X), 4:joChest2(Z), 5:joChest3(-Y)
//	(j
//6:joNeck1(-X), 7:joNeck2(Z), 8:joNeck3(-Y)
//	(E)
//9:joRShoulder1(X), 10:joRShoulder2(Z), 11:joRShoulder3(-Y)
//	(EI)
//12:joRElbow1(X), 13:joRElbow2(-Y)
//	(E)
//14:joRWrist1(-Z), 15:joRWrist2(X)
//	()
//16:joLShoulder1(X), 17:joLShoulder2(-Z), 18:joLShoulder3(Y)
//	(I)
//19:joLElbow1(X), 20:joLElbow2(Y)
//	()
//21:joLWrist1(Z), 22:joLWrist2(X)
//-------	  g   --------------
//	(EҊ֐)
//23:joRHip1(X), 24:joRHip2(Z), 25:joRHip3(-Y)
//	(EG)
//26:joRKnee(-X)
//	(E)
//27:joRAnkle1(X), 28:joRAnkle2(Z), 29:joRAnkle3(-Y)
//	(Ey܂)
//30:joRToe(-X)
//	(Ҋ֐)
//31:joLHip1(X), 32:joLHip2(-Z), 33:joLHip3(Y)
//	(G)
//34:joLKnee(-X)
//	()
//35:joLAnkle1(X), 36:joLAnkle2(-Z), 37:joLAnkle3(Y)
//	(y܂)
//38:joLToe(-X)
//////////////////////////////////////////////////////////////

#ifndef CRHuman_H
#define CRHuman_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Physics/PHSolid.h>
#include <Physics/PHJointPid.h>
#include <Physics/PHContactEngine.h>

#include <SceneGraph/SGScene.h>
#include <SceneGraph/SGFrame.h>

#include <Base/Affine.h>
#include <vector>

#include "CRSupportArea.h"

#define JOINT_NUM 39
#define SOLID_NUM 18

namespace Spr{;

struct CRHumanSolidInfo{
	Vec3f scaleRatio;	// eʂ̐gɑ΂/Q
	Vec3f scale;		// 
	float massRatio;	// eʂ̑S̏dɑ΂鎿ʔ

	Vec3f scaleSafeRatio;
	Vec3f massCenterPos;
};

struct CRHumanJointInfo{
	Vec3f parentPosScale;	// eê̊֐߈ʒu̐gɑ΂
	Vec3f childPosScale;	// eq̂̊֐߈ʒu̐gɑ΂
	float rangeMax;			// ől
	float rangeMin;			// ŏl
	float danpa;			// _pW
	float spring;			// olW
	float torqueMax;		// gN̍ől
	float torqueMin;		// gN̍ŏl
	float axis;				// [hWnɑ΂Ă̎̐̕
	float initPos;			// {p
};


DEF_RECORD(XHuman,{
	GUID Guid(){ return WBGuid("48CE97A5-A3C0-446f-A2A0-25D42168A1E4"); }
	FLOAT totalHeight;
	FLOAT totalMass;
});

class CRHuman: public SGBehaviorEngine{
public:
	friend class CRHumanLoader;
	friend class CRHumanSaver;
	SGOBJECTDEF(CRHuman);
	PHSolid* test;
	CRSupportArea supportArea;						// ̑Ŝ̈̈̌vZ
	std::vector<CRSupportArea> supportObject;		// ̂xSolid̐ڐG_̈vZ

///////////////////////  ϐ   /////////////////////////////////
public:
	UTRef<PHJointEngine> jointEngine;				//	WCgGW
	std::vector<PHSolid*> solids;					//	VH̊eʂ[
	std::vector<PHJointBase*> joints;				//	VH̊e֐߂[
	std::vector<PHJointPid*> jointPids;				//	VH̊e֐߂[
	std::vector<unsigned int> supportSolidNum[2];	//@VHx镔ʂ̔ԍ[(,ܐ)(0:E,1:j
	std::vector<unsigned int> ankleJointNum[2];		//
	std::vector<int> noUseJoint;					// œK(oX)ŎgȂ֐ߔԍ


	CRHumanJointInfo	jinfo[JOINT_NUM];			// VHJoint
	CRHumanSolidInfo	sinfo[SOLID_NUM];			// VHSolid

protected:
	bool bLoaded;	//@VH[h(Connct)ꂽۂ

	//VH̃p[^
	float totalMass;
	float totalHeight;


///////////////////////   ֐   ////////////////////////////////

public:
	CRHuman();
	virtual ~CRHuman();
	int GetPriority(){return SGBP_CREATURE;}

	///	LĂIuWFNg̐
	virtual size_t NChildObjects(){ return jointEngine ? 0 : 1; }
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i){ return jointEngine; }
	///	QƂĂIuWFNg̐
	virtual size_t NReferenceObjects(){ return 0; }
	///	QƂĂIuWFNg
	virtual SGObject* ReferenceObject(size_t i){ return NULL; };
	///	qIuWFNg̒ǉ(LEQƂȂ)
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s){ return false; }

	// {C^[tF[X
	virtual void Load(SGScene* scene);				// {ݒBFrameWorkLoadŌĂ΂B
	virtual void Loaded(SGScene* scene);			// {ݒB
	virtual void LoadDerivedModel(SGScene* scene){}	//hf(User,VH)̐ݒ

	bool IsLoaded(){ return bLoaded; }				// [h̊mF
	void SetLoaded(bool load){bLoaded = load;}		// ̑Ŝǂݍ܂eXgꍇ
	bool HasFrame(SGFrame* f);

	// VHRg[\ɂ(Solid,Joint̎擾)
	virtual bool Connect(UTRef<SGScene> scene);
	void ConnectSolid(const char* name, UTRef<SGScene> scene);
	void ConnectJoint(const char* name, UTRef<SGScene> scene);

	//VH̊ep[^̐ݒ
	void SetModel(SGScene* scene);				// ȉ̐ݒ֐gAVHg悤ɂB
	void SetTotalMass(float mass);
	void SetTotalHeight(float height);
	void SetMass();

	virtual void SetSolidInfo();
	virtual void SetJointInfo();
	virtual void SetJointRange();
	void SetOneJointRange(PHJoint1D* j, float min, float max);

	virtual void SetInertia();
	void SetOneInertia(Spr::PHSolid* solid, Spr::Vec3f Axis);
	void JointPIDMul(PHJointPid* jo, float mulP, float mulD);
	virtual void SetJointSpring(float dt);	

	void AddJointPassivityResistance();
	
	// f̃XP[Zbg
	void SetScale(SGScene* scene);
	void SetSolidScale();
	void SetJointScale();

	// f̏p
	virtual void SetJointInitAngle();

	// VHSolid,Joint擾
	CRHumanSolidInfo GetSolidInfo(int i){return sinfo[i];}
	CRHumanJointInfo GetJointInfo(int i){return jinfo[i];}
	float GetTotalMass(){return totalMass;}						// VH̑S̏d擾
	Vec3f GetCOG();												// VH̏dS̈ʒu擾
	Vec3d GetCogVelocity();										// VH̏dS̑x擾


	void CalcContactForce();
	virtual void RegistSupportParts(UTRef<SGScene> scene){}		// oXɂđ̎xSolido^(EAȂ)
	virtual void SetBodyNum(){}									// oXȂǂɕKvSolid,Joint̔ԍ̓o^
protected:
	void LoadX(const XHuman& xh);
	void SaveX(XHuman& xh) const;

};

}	//	end namespace Spr
#endif // !defined(CRHuman_H)
