#ifndef FWAPP_H
#define FWAPP_H
#include "FWPointer.h"
#include <SceneGraph/SGScene.h>
#include <Graphics/GRRender.h>
#include <HIS/HIMouse.h>
#include <Device/DVDeviceManager.h>
#include <WinBasis/WBCriticalSection.h>
#include <WinBasis/WBMMTimer.h>

namespace Spr{;

class FWApp:public UTRefCount{
protected:
	HWND hWnd;							//	EBhEnh

	WBCriticalSection cs;				//	NeBJZNV
	Spr::WBMMTimer timer;				//	V~[Vp}`fBA^C}[
	UINT simuTimerId;					//	V~[VpWM^C}[ID
	float defaultTimeStep;				//	V[Ɏԍ݂ĂȂƂɎgԍ
	bool bPause;						//	ꎞ~tO
	volatile bool bBusy;				//	vZԂɍȂƂ true ɂȂD
	bool bOutForce;						//	͊o񎦂sǂ
	float simuTimerPeriod;
	//	
	UTString initialLoadFile;			//	V[łOɁC[hĂ΂ꂽꍇCt@CɊoĂ
	UTString lastLoadFile;				//	ŌɃ[ht@C
	std::vector<std::string> fileList;	//	t@C؂ւꍇ̃t@CXg
	int fileListCur;					//	t@CXgł̈ʒu
public:
	enum {
		TIMER_SIMU = 1,
		TIMER_DRAW = 2,
	};
	enum {TIMERTICK = 1000};
	UTRef<SGScene> scene;
	UTRef<GRRender> render; 
	FWPointers pointers;
	UTRef<HIMouse> mouse;
	DVDeviceManager devMan;

	FWApp();
	virtual ~FWApp();

	virtual void InitDevice();
	float GetSimuTimerPeriod(){return simuTimerPeriod;}
	virtual void Init(HWND hWnd);
	virtual void Step();
	virtual bool AddHis(const char* type);
	virtual void ClearHis();
	virtual void ConnectHis();

	virtual bool PreviewMessage(MSG* pMsg);

	virtual void Draw();
	virtual void CreateD3DRender();
	virtual void CreateGLRender();
	virtual void LoadList();
	virtual void Load(UTString fn);
	virtual void LoadImp(UTString fn){}
	virtual void Save(UTString fn);
	virtual void SaveImp(UTString fn){}
	virtual bool OnKeyDown(unsigned int key);
	virtual void Reset();
protected:
	static void TimerFunc(void* arg);
	static void CALLBACK WMTimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);

};

}
#endif
