#include <iostream>
#include "His/HISpidar4.h"


#ifdef _WIN32
 #include <windows.h>
 #include <conio.h>

 //	USB2.0AṽhCo
 #include <Device/DRUsb20Simple.h>
 #include <Device/DRUsb20Sh4.h>
 //	ContectISAJ[h̃hCoDÂ(1997-)D
 //#include "Device/DRContecIsaDa.h"
 //#include "Device/DRContecIsaCounter.h"
 //#include <Device/DRUsbH8Simple.h>
#endif

#ifdef __sh__
 #include <cyg/kernel/kapi.h>
 #include <Device/DRIHCSh4.h>
 int kbhit(){return false;}
 int getch(){ return 0;}
 void Sleep(int msec){
	cyg_thread_delay(msec*10);
 }
 #define cout DSTR
#endif

using namespace Spr;	//	SprSpringheadCu̖O
using namespace std;

int main(){
	//------------------------------------------------------------------------
	//	
	//
	DVDeviceManager devMan;		//	foCXhCoĂꕨ

#ifdef _WIN32
	devMan.RPool().Register(new DRUsb20Simple(10));	//	USB2.0Av(ID 10)o^
	devMan.RPool().Register(new DRUsb20Sh4(0));		//	SH4Av(ID 0)o^
	//	ID̓Aṽ[^XCb`̒l(0x0-0xF)łD

	/*	gĂȂhCoDo^ĂΎFD
	devMan.RPool().Register(new DRUsbH8Simple(0));
	devMan.RPool().Register(new DRContecIsaDa(0x300));
	devMan.RPool().Register(new DRContecIsaCounter(0x200));
	devMan.RPool().Register(new DRContecIsaCounter(0x210));
	*/
	bool bMinForce = true;							//	Ȃ͂oƊ댯Ȃ̂ŁCXy[X܂ł͍ŏ͂o
	const float K = 2000.0f;						//	΂˒萔
#endif
#ifdef __sh__
	devMan.RPool().Register(new DRIHCSh4);			//	SH4pRealDeviceo^
	bool bMinForce = false;							//	SH̏ꍇ͒ʐMłȂ̂ŁCŏON
	const float K = 20000.0f;						//	΂˒萔 10kHz10{
#endif

	/*	hCȍD݂foCXɑΉo[`foCX
		ŏ	*/
	devMan.Init();
	cout << devMan;	//	foCX̏Ԃ̕\

	HISpidar4 spidar;
	HISpidar4 spidar2;

	//	SPIDAȐD{́Cn[hEGA HISpidar4 NXhׂ
	//	[^̎tʒu. [^̂ɎtĂꍇ́C
	#define PX	0.265f	//	x̕ӂ̒/2
	#define PY	0.265f	//	y̕ӂ̒/2
	#define PZ	0.265f	//	z̕ӂ̒/2
	Vec3f motorPos[][4] = {	//	[^̎tʒu(S_Ƃ)
		{Vec3f(-PX, PY, PZ),	Vec3f( PX, PY,-PZ), Vec3f(-PX,-PY,-PZ), Vec3f( PX,-PY, PZ)},
		{Vec3f( PX, PY, PZ),	Vec3f(-PX, PY,-PZ), Vec3f( PX,-PY,-PZ), Vec3f(-PX,-PY, PZ)}
	};
	cout.flush();
	spidar.Init(devMan, motorPos[0], 0.3776f, 2.924062107079e-5f, 0.5f, 20.0f);
	spidar2.Init(devMan, motorPos[1], 0.3776f, -2.924062107079e-5f, 0.5f, 20.0f);
	cout.flush();
	printf("Waiting...");
	Sleep(1000);
	printf("Calibration\n");
	spidar.Motor()[0].lengthPerPulse *= -1;
	spidar2.Motor()[0].lengthPerPulse *= -1;
	spidar2.Motor()[2].lengthPerPulse *= -1;

	spidar.Calib();
	spidar2.Calib();
	
	//------------------------------------------------------------------------
	//	C[v
	//
	while(1){
		if (kbhit()){	//	L[
			int ch = getch();
			switch(ch){
			case ' ':		//	Xy[XF͊oON/OFF
				bMinForce = !bMinForce;
				break;
			case 0x1b:		//	ESC:I
				goto end;
				break;
			}
		}
		
		spidar.Update(0.001f);				//	AvƂ̒ʐM(͂񎦁Eʒu擾)
		Vec3f force;					//	񎦂
		if (spidar.GetPos().Y() < 0){	//	̒
			force.Y() = - K * spidar.GetPos().Y();
		}
		if (force.norm() > 10){			//	傫͂͒񎦂łȂ̂ŁC10Nɐ
			force = force.unit() * 10;
		}
		//------------------------------------------------------------------------
		//	񎦗͂̐ݒ
		if (bMinForce) spidar.SetMinForce();
		else spidar.SetForce(force);

		//	ȉ2ԖڂSPIDARɂēlɁC
		Vec3f force2;
		spidar2.Update(0.001f);
		if (spidar2.GetPos().Y() < 0){
			force2.Y() = - K * spidar2.GetPos().Y();
		}
		if (bMinForce) spidar2.SetMinForce();
		else spidar2.SetForce(force2);
		//	fobOpFʒuƗ͂\
#if 0
		cout << "P:" << spidar.GetPos() << "\tF:" << spidar.GetForce() << std::endl;
#endif
		//	fobOpF̒\
#if 1
		for(int i=0; i<4; i++){
			cout << spidar.Motor()[i].GetLength() << " ";
		}
		for(int i=0; i<4; i++){
			cout << spidar2.Motor()[i].GetLength() << " ";
		}
		cout << std::endl;
		cout.flush();
#endif
	} 
end:;
	return 0;
}
