#ifndef VR_REND_RENDER_H
#define VR_REND_RENDER_H
#include <Base/Affine.h>
#include <vector>

namespace Spr {

/**	@mainpage LVRM Render Cu
*/

///	RDView  --  display class
class RDView{
protected:
	///	^C}[nh[̊NX
	class TTimerHandlerBase{
	public:
		int interval;
		virtual bool Call()=0;
	};
	///	^C}[nh[NX̔z
	class TTimerHandlerBases:public std::vector<TTimerHandlerBase*>{
	public:
		int Add(TTimerHandlerBase* handler){
			for(iterator it=begin(); it!=end(); ++it){
				if (!*it){
					*it = handler;
					return it - begin();
				}
			}
			push_back(handler);
			return size()-1;
		}
		void Del(int id){
			delete begin()[id];
			begin()[id] = NULL;
		}
	};
	///	^C}[nh[{
	template <class T, class F> class TTimerHandler: public TTimerHandlerBase{
	public:
		F func;
		T* that;
		TTimerHandler(int i, T* t, F f): that(t), func(f){ interval=i; }
		bool Call(){ return (that->*func)(); }
	};
	///	^C}[nh[Ăz
	TTimerHandlerBases timerHandlers;
	
	///	XVvtO
	bool invalidated;
	///	^C}[ۂɃZbg֐D
	virtual void DoSetTimer(int id){}
public:
	///	L[{[h̏ԂϐD
	int keyboard[256];
	///	L[̏ԂϐD
	int specialKey[256];
	///
	RDView();
	///
	virtual ~RDView();
	//	operation
	///	Init and create window.
	virtual void Init(const char* window_title)=0;
	///	Run main loop.
	virtual void Run()=0;
	///	Quit the program.
	virtual void Exit()=0;

	///	Set window position.
	virtual void WindowPosition(int x, int y, int w, int h)=0;
	///	Flip (update) buffer.
	virtual void Flip()=0;
	///	Request rendering.
	void Invalidate(){ invalidated = true; }
	///	Cancel the request of rendering.
	void Validate(){invalidated = false; }
	
	///	^C}[̐ݒ
	template <class T>
	int SetTimer(int interval, bool (T::*func)()){
		typedef bool (T::*FUNC)();
		int id = timerHandlers.Add(new TTimerHandler<T,FUNC>(interval, (T*)this, func));
		DoSetTimer(id);
		return id;
	}
	///	^C}[̉
	void ReleaseTimer(int id){ timerHandlers.Del(id); }

	///	L[{[h(ʂ̃L[)̏
	virtual bool Keyboard(int code){
		if(code<0 || code>sizeof(keyboard)/sizeof(keyboard[0])) return false;
		return keyboard[code] != 0;
	}
	///	L[{[h(L[)̏
	virtual bool SpecialKey(int code){
		if(code<0 || code>sizeof(specialKey)/sizeof(specialKey[0])) return false;
		return specialKey[code] != 0;
	}
public:
	//	Call backs.
	///	`vƂɌĂяoR[obN
	virtual void OnDraw(){}
	///	Ђ܂ȂƂɌĂяoR[obN
	virtual void OnIdle(){}
	///	EBhETCYωƂɌĂяoR[obN
	virtual void OnSize(int w, int h){}
	///	ŏ̃EBhEJ܂ɌĂяoR[obN
	virtual void OnOpen(){}
	///	vOIOɌĂяoR[obN
	virtual void OnClose(){}
	///	}EX̃{^\
	enum Button {NONE, LEFT, MIDDLE, RIGHT};
	///	}EXNbNꂽƂɌĂяoR[obN
	virtual void OnMouse(Button b, bool on, int x, int y){}
	///	}EXƂɌĂяoR[obN
	virtual void OnMouseMove(bool on, int x, int y){}
	///	L[͎ɌĂяoR[obN
	virtual void OnKeyboard(int code, int x, int y){}
	///	Ȃǂ̓L[͎ɌĂяoR[obN
	virtual void OnSpecialKey(int code, int x, int y){}
	///	WCXeBbÑR[obN
	virtual void OnJoystick(unsigned int button, int x, int y, int z){}
};

 
}
#endif
