#ifndef PHWATER_H
#define PHWATER_H

#include <Base/Affine.h>
#include <FileIO/FIDocScene.h>
#include <SceneGraph/SGScene.h>
#include <Graphics/GRVisual.h>
#include <Physics/PHSolid.h>

using namespace PTM;
namespace Spr{;

/*
	E݌vɂĂWaterContainerƂK
	EPHWaterClearForcȇΏۂSolidɌ炸͂̑SʂȂ̂ŁA
		PHClearForceƂׂ

	PHWater̍W̎F
	EZ͐ÐʂɒAD
	EiqxɊiqmx + 1Cmx * dhCyɊiqmy + 1Cmy + dhD
	EW_͊iq̒D
	ÊƂ됅[depth̓XJ萔heightƓiqƂɈقȂlƂ悤Ɋg
*/

class D3Mesh;
class GLMesh;
class GRMaterial;
class D3Material;
class D3Render;
class GLRender;

class PHWaterTrackTarget : public SGObject{
public:
	SGOBJECTDEF(PHWaterTrackTarget);

	bool		AddChildObject(SGObject* o, SGScene* s);
	size_t		NReferenceObjects(){return targets.size();}
	SGObject*	ReferenceObject(size_t i){return targets[i];}

	SGFrames targets;
};

class PHWater : public GRVisual{
public:
	SGOBJECTDEF(PHWater);
	bool		AddChildObject(SGObject* o, SGScene* s);///< [hɎgpD
	size_t		NReferenceObjects();					///< 
	SGObject*	ReferenceObject(size_t i);				///< t[ԂD
	void		Loaded(SGScene* scene);					///< [hȈ
	void		Step(SGScene* s);						///< i߂D
	Affinef		GetPosture(){ return frame->GetWorldPosture(); }

	///	_O
	virtual void Render(SGFrame* fr, GRRender* render);

	///͂NA
	void ClearForce(){}

	///iqԂ̒l`⊮ĕԂ
	double LerpHeight(double x, double y);

	//p[^
	UTRef<SGFrame> frame;	//	et[
	int		my, mx;			//
	TVec2<int> bound;		//E ̃ZƎ̃ZẼZɂȂD
	TVec2<int> texOffset;	//bound ƓC%mx ȂD
	Vec2d	velocity;		//헬DIɂ̑xŐD
	double	dh, dhinv;		//iq̕
	double	depth;			//[
	double	gravity;		//d
	double	density;		//x
	double	loss;			//W

	PHWater();
	friend class PHWaterContactEngine;
	friend struct PHWConvexCalc;

protected:
	typedef VMatrixCol<double> matrix_type;
	typedef VMatrixCol<Vec3d>	v3matrix_type;
	typedef VVector<double> vector_type;

	//Ǐ]Ώ
	UTRef<PHWaterTrackTarget> targets;

	UTRef<GRMaterial> material;
	UTRef<D3Material> materialD3;

	int				mxy;	//mx * my
	double			rx;		//mx * dh / 2.0
	double			ry;		//my * dh / 2.0
	
	matrix_type		p;				//
	matrix_type		u, utmp;		//x
	matrix_type		v, vtmp;		//y
	matrix_type		height, htmp;	//
	v3matrix_type	normal;			//@
	v3matrix_type	tvec;			//
	Vec3d			vlight;			//̌

	///
	void Init(SGScene* scene);

	///Eݒ肷
	void Bound();

	///ϕ
	void Integrate(double dt);

	///܃xNǧvZ
	Vec3d calRefracVec(Vec3d n, Vec3d v, double ra);

	void RenderD3(SGFrame* fr, D3Render* render);
	void RenderGL(SGFrame* fr, GLRender* render);
	DWORD GetColor(float h);
};

typedef UTRefArray<PHWater> PHWaters;

class PHWaterEngine : public /*SGBehaviorEngine*/PHSolverBase{
public:
	SGOBJECTDEF(PHWaterEngine);

	PHWaters waters;
	
	bool AddChildObject(SGObject* o, SGScene* s);
	bool DelChildObject(SGObject* o, SGScene* s);
	int GetPriority() const {return SGBP_DYNAMICALSYSTEM;}
	virtual void Step(SGScene* s);
	virtual void ClearForce();
	virtual void Loaded(SGScene* scene);
	virtual void Clear(SGScene* s);
	virtual size_t NChildObjects(){ return waters.size(); }
	virtual SGObject* ChildObject(size_t i){ return (SGObject*)&*(waters[i]); }

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
};

}

#endif