#ifndef Spr_WXD3D_WXD3Dev_H
#define Spr_WXD3D_WXD3Dev_H
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "../DDraw/WXDDraw.h"
#include "../DDraw/WXDDFSurf.h"
#include "WXD3Affine.h"
#include <d3d.h>

namespace Spr {

//----------------------------------------------------------------------------
//	WXD3Driver
///	3D_OhCoɑΉNX
class SPR_DLL WXD3Driver{
public:
	///	3D_OhCoGUID
	GUID guid;
	///	3D_OhCo̐
	std::string about; 
	///	3D_OhCo̖O
	std::string name; 
	///	HALǂ
	bool bHAL;
	///	desc7gp邩ǂ
	bool bDesc7;
private:
#if DIRECTDRAW_VERSION >= 0x700
	///	쐬łT[tFCXɂĂ̋Lq(DirectX7ȍ~)
	D3DDEVICEDESC7 desc7;
#endif
	///	쐬łT[tFCXɂĂ̋Lq
	D3DDEVICEDESC desc;

public:
	WXD3Driver();
	int ZBufferDepth(int max=16);
	/**	w肳ꂽF̃T[tFCXɃ_O\
		@param	bitPerPixel	1sNZ̃rbg.
		@result	\Ȃ true.		*/
	bool CheckRendDepth(int bitPerPixel);
	void SetDesc(D3DDEVICEDESC& d);
	D3DDEVICEDESC* GetDesc(){ return bDesc7 ? NULL : &desc; }
#if DIRECTDRAW_VERSION >= 0x700
	void SetDesc(D3DDEVICEDESC7& d7);
	D3DDEVICEDESC7* GetDesc7(){ return bDesc7 ? &desc7 : NULL; }
#endif
protected:
	DWORD ZBufferDepthMask();
};
//----------------------------------------------------------------------------
//	WXD3Drivers

///	3D_OhCo̔z
class SPR_DLL WXD3Drivers: public std::vector<WXD3Driver>{
protected:
	int cur;
	bool Select(int rendDepth, bool bHALOK=true);
	bool Select();
public:
	///	g3D_w
	int prefer;
	WXD3Drivers();
	int Cur(){return cur;}
	///	ݎgp3D_
	WXD3Driver& CurDriver();
	///	gp3D_ id ɂB(łȂƂ)
	void Set(int id);
#if DIRECTDRAW_VERSION >= 0x700
	static HRESULT PASCAL EnumDevicesCallback(char* desc, char* name, D3DDEVICEDESC7* devDesc, void* pContext);
#endif
	static HRESULT PASCAL EnumDevicesCallback(GUID* pGuid, char* a, char* n, D3DDEVICEDESC* pHAL, D3DDEVICEDESC* pHEL, void* pContext);
	friend class WXD3Device;
	friend class WXD3DPDevice;
};

//----------------------------------------------------------------------------
//	WXD3Device
//
///	3D`\ȃT[tFCX
class SPR_DLL WXD3Device:public WXDDFlipSurface{
public:
#if DIRECTDRAW_VERSION >= 0x0500
	typedef IDirect3DDevice2 intf_type;
#else
	typedef IDirect3DDevice intf_type;
#endif
	///	gp3D_
	WXD3Drivers drivers;
	///	foCXCOMC^tFCX
	intf_type* pD3DDev;
	intf_type* operator ->() const {return pD3DDev;}
	intf_type* operator ->() {
		if (!pD3DDev) Create();
		return pD3DDev;
	}
	///
	WXD3Device();
	~WXD3Device();
	///	`fBXvCJ[h̐ݒ
	virtual void DDraw(WXDDraw& dd);
	///	gp\3D_
	virtual bool EnumDrivers();
	///	T[tFCX̍쐬
	virtual bool Create(){return Create(true);}
	///	T[tFCX̊J
	virtual void Release(){Release(true);}
	///	T[tFCXĂΕ
	virtual bool Restore();

protected:
	virtual bool Create(bool bCallCallback, int nBackBuffer);
	virtual bool Create(bool bCallCallback){ return Create(bCallCallback, 1); }
	virtual void Release(bool bCallCallback);
	class SPR_DLL CZSurface:public WXDDSurface {
		virtual bool Create(){ return Create(true); }
		virtual bool Create(bool bCallCallback){ return Create(16, true, true); }
		virtual bool Create(DWORD depth, bool bHardWare, bool bCallCallback=true);
		friend WXD3Device;
	}zBuffer;
	friend class WXRM;
	friend class WXD3IM;
};
}	//	namespace Spr
#endif
